using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Tools;

namespace MdiTabsTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		#region Fields

		Hashtable tabbedMdiChilds = new Hashtable();

		#endregion

		#region Designer Fields

		private Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager barManager;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar menuBar;
		private System.Windows.Forms.Panel panelMdiTabs;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem2;
		private Syncfusion.Windows.Forms.Tools.CommandBar commandBarMdiTabs;
		private MdiTabControl tabControlMdiTabs;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem4;
		private Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenusManager popupMenusManager;
		private Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenu popupMenuMdiTabs;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItemMdiTabs;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemMdiTabsClose;
		private System.Windows.Forms.ImageList imageList;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar1;
		private System.ComponentModel.IContainer components;

		#endregion

		#region Construction / Dispose

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.barManager = new Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager(this.components, this);
			this.menuBar = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.barManager, "menuBar");
			this.parentBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.imageList = new System.Windows.Forms.ImageList(this.components);
			this.barItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.parentBarItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.bar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.barManager, "toolBar");
			this.commandBarMdiTabs = new Syncfusion.Windows.Forms.Tools.CommandBar();
			this.panelMdiTabs = new System.Windows.Forms.Panel();
			this.tabControlMdiTabs = new MdiTabsTest.MdiTabControl();
			this.barItem4 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.popupMenusManager = new Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenusManager(this.components);
			this.popupMenuMdiTabs = new Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenu(this.components);
			this.parentBarItemMdiTabs = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItemMdiTabsClose = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			((System.ComponentModel.ISupportInitialize)(this.barManager)).BeginInit();
			this.commandBarMdiTabs.SuspendLayout();
			this.panelMdiTabs.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.tabControlMdiTabs)).BeginInit();
			// 
			// barManager
			// 
			this.barManager.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("barManager.BarPositionInfo")));
			this.barManager.Bars.Add(this.menuBar);
			this.barManager.Bars.Add(this.bar1);
			this.barManager.Categories.Add("File");
			this.barManager.Categories.Add("View");
			this.barManager.CurrentBaseFormType = "";
			this.barManager.DetachedCommandBars.Add(this.commandBarMdiTabs);
			this.barManager.Form = this;
			this.barManager.ImageList = null;
			this.barManager.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																									this.parentBarItem1,
																									this.barItem1,
																									this.barItem2,
																									this.parentBarItem2,
																									this.barItem3});
			this.barManager.LargeImageList = null;
			this.barManager.ResetCustomization = false;
			this.barManager.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
			// 
			// menuBar
			// 
			this.menuBar.BarName = "menuBar";
			this.menuBar.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)(((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.IsMainMenu) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.UseWholeRow) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder)));
			this.menuBar.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																								 this.parentBarItem1,
																								 this.parentBarItem2});
			this.menuBar.Manager = this.barManager;
			// 
			// parentBarItem1
			// 
			this.parentBarItem1.CategoryIndex = 0;
			this.parentBarItem1.ID = "Application";
			this.parentBarItem1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItem1,
																										this.barItem2});
			this.parentBarItem1.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
			this.parentBarItem1.Text = "File";
			// 
			// barItem1
			// 
			this.barItem1.CategoryIndex = 0;
			this.barItem1.ID = "Open Child Form 1";
			this.barItem1.ImageIndex = 1;
			this.barItem1.ImageList = this.imageList;
			this.barItem1.LargeImageList = this.imageList;
			this.barItem1.Shortcut = System.Windows.Forms.Shortcut.F2;
			this.barItem1.Text = "Open Child Form 1";
			this.barItem1.Click += new System.EventHandler(this.barItem1_Click);
			// 
			// imageList
			// 
			this.imageList.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList.ImageStream")));
			this.imageList.TransparentColor = System.Drawing.Color.Magenta;
			// 
			// barItem2
			// 
			this.barItem2.CategoryIndex = 0;
			this.barItem2.ID = "Open Child Form 2";
			this.barItem2.ImageIndex = 2;
			this.barItem2.ImageList = this.imageList;
			this.barItem2.LargeImageList = this.imageList;
			this.barItem2.Shortcut = System.Windows.Forms.Shortcut.F3;
			this.barItem2.Text = "Open Child Form 2";
			this.barItem2.Click += new System.EventHandler(this.barItem2_Click);
			// 
			// parentBarItem2
			// 
			this.parentBarItem2.CategoryIndex = 1;
			this.parentBarItem2.ID = "View";
			this.parentBarItem2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItem3});
			this.parentBarItem2.Text = "View";
			this.parentBarItem2.BeforePopup += new System.ComponentModel.CancelEventHandler(this.parentBarItem2_BeforePopup);
			// 
			// barItem3
			// 
			this.barItem3.CategoryIndex = 1;
			this.barItem3.ID = "MDI tabs";
			this.barItem3.Text = "MDI tabs";
			this.barItem3.Click += new System.EventHandler(this.barItem3_Click);
			// 
			// bar1
			// 
			this.bar1.BarName = "toolBar";
			this.bar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.barItem1,
																							  this.barItem2});
			this.bar1.Manager = this.barManager;
			// 
			// commandBarMdiTabs
			// 
			this.commandBarMdiTabs.AllowedDockBorders = ((Syncfusion.Windows.Forms.Tools.CommandBarDockBorder)((Syncfusion.Windows.Forms.Tools.CommandBarDockBorder.Top | Syncfusion.Windows.Forms.Tools.CommandBarDockBorder.Bottom)));
			this.commandBarMdiTabs.Controls.Add(this.panelMdiTabs);
			this.commandBarMdiTabs.DockState = Syncfusion.Windows.Forms.Tools.CommandBarDockState.Top;
			this.commandBarMdiTabs.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World);
			this.commandBarMdiTabs.HideDropDownButton = true;
			this.commandBarMdiTabs.MaxLength = 500;
			this.commandBarMdiTabs.MinHeight = 30;
			this.commandBarMdiTabs.MinLength = 50;
			this.commandBarMdiTabs.Name = "commandBarMdiTabs";
			this.commandBarMdiTabs.OccupyFullRow = true;
			this.commandBarMdiTabs.RowIndex = 2;
			this.commandBarMdiTabs.RowOffset = 0;
			this.commandBarMdiTabs.TabIndex = 2;
			this.commandBarMdiTabs.TabStop = false;
			this.popupMenusManager.SetXPContextMenu(this.commandBarMdiTabs, this.popupMenuMdiTabs);
			// 
			// panelMdiTabs
			// 
			this.panelMdiTabs.Controls.Add(this.tabControlMdiTabs);
			this.panelMdiTabs.DockPadding.Top = 2;
			this.panelMdiTabs.Location = new System.Drawing.Point(10, 1);
			this.panelMdiTabs.Name = "panelMdiTabs";
			this.panelMdiTabs.Size = new System.Drawing.Size(580, 28);
			this.panelMdiTabs.TabIndex = 5;
			// 
			// tabControlMdiTabs
			// 
			this.tabControlMdiTabs.BackColor = System.Drawing.SystemColors.Control;
			this.tabControlMdiTabs.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.tabControlMdiTabs.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControlMdiTabs.FocusOnTabClick = false;
			this.tabControlMdiTabs.Location = new System.Drawing.Point(0, 2);
			this.tabControlMdiTabs.Name = "tabControlMdiTabs";
			this.tabControlMdiTabs.Size = new System.Drawing.Size(580, 26);
			this.tabControlMdiTabs.TabIndex = 0;
			this.tabControlMdiTabs.ThemesEnabled = true;
			this.tabControlMdiTabs.SelectedIndexChanged += new System.EventHandler(this.tabControlMdiTabs_SelectedIndexChanged);
			// 
			// barItem4
			// 
			this.barItem4.CategoryIndex = -1;
			this.barItem4.ID = "Close Window";
			this.barItem4.Text = "Close Window";
			// 
			// popupMenuMdiTabs
			// 
			this.popupMenuMdiTabs.ParentBarItem = this.parentBarItemMdiTabs;
			// 
			// parentBarItemMdiTabs
			// 
			this.parentBarItemMdiTabs.CategoryIndex = -1;
			this.parentBarItemMdiTabs.ID = "";
			this.parentBarItemMdiTabs.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																											  this.barItemMdiTabsClose});
			this.parentBarItemMdiTabs.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
			this.parentBarItemMdiTabs.BeforePopup += new System.ComponentModel.CancelEventHandler(this.parentBarItemMdiTabs_BeforePopup);
			// 
			// barItemMdiTabsClose
			// 
			this.barItemMdiTabsClose.CategoryIndex = -1;
			this.barItemMdiTabsClose.ID = "Close Window";
			this.barItemMdiTabsClose.ImageIndex = 0;
			this.barItemMdiTabsClose.ImageList = this.imageList;
			this.barItemMdiTabsClose.LargeImageList = this.imageList;
			this.barItemMdiTabsClose.Text = "Close";
			this.barItemMdiTabsClose.Click += new System.EventHandler(this.barItemMdiTabsClose_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 446);
			this.IsMdiContainer = true;
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "MDI Tabs";
			this.MdiChildActivate += new System.EventHandler(this.Form1_MdiChildActivate);
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.barManager)).EndInit();
			this.commandBarMdiTabs.ResumeLayout(false);
			this.panelMdiTabs.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.tabControlMdiTabs)).EndInit();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		#region Mdi Tabs related stuff

		private void Form1_MdiChildActivate(object sender, System.EventArgs e)
		{
			// Get the active MDI child form
			Form activeMdiChild = this.ActiveMdiChild;
			if (this.ActiveMdiChild != null)
			{
				// Automatically show the MdiTabs bar
				if (this.tabbedMdiChilds.Count == 0)
				{
					this.commandBarMdiTabs.Visible = true;
				}

				if (this.tabbedMdiChilds.Contains(activeMdiChild))
				{
					// Activate tabpage according to active MDI child
					this.tabControlMdiTabs.SelectedTab = this.tabbedMdiChilds[activeMdiChild] as TabPageAdv;
				}
				else
				{
					if (this.tabControlMdiTabs.ImageList == null)
					{
						this.tabControlMdiTabs.ImageList = new ImageList();
					}
					// Add the MDI child's icon to the tabcontrol's image list
					this.tabControlMdiTabs.ImageList.Images.Add(activeMdiChild.Icon.ToBitmap());

					// Create a new tabpage
					TabPageAdv tabPage = new TabPageAdv(activeMdiChild.Text);
					// Cache reference to the MDI child
					tabPage.Tag = activeMdiChild;
					// Set image index
					tabPage.ImageIndex = this.tabControlMdiTabs.ImageList.Images.Count - 1;

					// Add tabpage to the tabcontrol
					this.tabControlMdiTabs.TabPages.Add(tabPage);
				
					// Add MDI child and tabpage to the hashtable (MDI child is key, tabpage is value)
					this.tabbedMdiChilds.Add(activeMdiChild, tabPage);

					// Register "Closed" event handler to the MDI child
					activeMdiChild.Closed += new EventHandler(mdiChild_Closed);				
				}
			}
			else
			{
				// Automatically hide the MdiTabs bar
				if (this.tabbedMdiChilds.Count == 0)
				{
					this.commandBarMdiTabs.Visible = false;
				}
			}
		}

		private void tabControlMdiTabs_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (this.tabControlMdiTabs.SelectedTab != null)
			{
				// Active MDI child according to the selected tabpage
				((Form)this.tabControlMdiTabs.SelectedTab.Tag).Activate();
			}
		}

		private void mdiChild_Closed(object sender, EventArgs e)
		{
			Form mdiChild = sender as Form;
			if (mdiChild == null)
				return;

			System.Diagnostics.Debug.Assert(this.tabbedMdiChilds.Contains(mdiChild));

			// Get the tabpage from the hashtable
			TabPageAdv tabPage = this.tabbedMdiChilds[mdiChild] as TabPageAdv;

			// Get index of tabpage
			int tabPageIndex = this.tabControlMdiTabs.TabPages.IndexOf(tabPage);
			// Remove tabpage from tabcontrol
			this.tabControlMdiTabs.TabPages.RemoveAt(tabPageIndex);

			// Remove image from imagelist
			this.tabControlMdiTabs.ImageList.Images.RemoveAt(tabPageIndex);

			// Reorder image indices of tabpages
			for (tabPageIndex = 0; tabPageIndex < this.tabControlMdiTabs.TabPages.Count; tabPageIndex++)
			{
				this.tabControlMdiTabs.TabPages[tabPageIndex].ImageIndex = tabPageIndex;
			}

			// Remove Mdi child from Hashtable
			this.tabbedMdiChilds.Remove(mdiChild);

			// Unregister "Closed" event handler
			mdiChild.Closed -= new EventHandler(mdiChild_Closed);
		}


		#endregion

		#region Other

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.barItem1.PerformClick();
			this.barItem2.PerformClick();

			// Set RowIndex to dock the MdiTabs bar below the toolbar
			this.commandBarMdiTabs.RowIndex = 2;
		}

		
		private void barItem1_Click(object sender, System.EventArgs e)
		{
			Form2 form = new Form2();
			form.MdiParent = this;
			form.Show();
		}

		private void barItem2_Click(object sender, System.EventArgs e)
		{
			Form3 form = new Form3();
			form.MdiParent = this;
			form.Show();
		}

		private void barItem3_Click(object sender, System.EventArgs e)
		{
			this.commandBarMdiTabs.Visible = !this.commandBarMdiTabs.Visible;			
		}

		private void parentBarItem2_BeforePopup(object sender, System.ComponentModel.CancelEventArgs e)
		{
			this.barItem3.Checked = this.commandBarMdiTabs.Visible;
		}		
		
		private void barItemMdiTabsClose_Click(object sender, System.EventArgs e)
		{
			if (this.tabControlMdiTabs.SelectedTab != null)
			{
				((Form)this.tabControlMdiTabs.SelectedTab.Tag).Close();
			}
		}

		private void parentBarItemMdiTabs_BeforePopup(object sender, System.ComponentModel.CancelEventArgs args)
		{
			args.Cancel = this.tabControlMdiTabs.TabPages.Count == 0;
		}


		#endregion
	}
}