using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MdiTabsTest
{
	public class MdiTabControl : Syncfusion.Windows.Forms.Tools.TabControlAdv 
	{
		public MdiTabControl()
			: base()
		{
		}

		protected override void OnPaint(PaintEventArgs args)
		{
			if (!args.ClipRectangle.IsEmpty)
			{
				System.Drawing.Brush brush = new System.Drawing.Drawing2D.LinearGradientBrush(args.ClipRectangle, Syncfusion.Windows.Forms.Office2003Colors.MenuMarginColorLight, Syncfusion.Windows.Forms.Office2003Colors.MenuMarginColorDark, 90, true);
				args.Graphics.FillRectangle(brush, args.ClipRectangle);
			}

			base.OnPaint(args);
		}
	}
}
